----------------------------------------------------
--      VHDL code generated by Visual HDL
--  Root of Design:
--  ---------------
--      Unit    Name :  recnt
--      Library Name :  updn4
----------------------------------------------------
--  Library Name :  updn4
--  Unit    Name :  rotary
--  Unit    Type :  Text Unit
----------------------------------------------------
library ieee; use ieee.std_logic_1164.all;

entity  rotary  is
  port (y,z,clk,A,B :  in std_logic ;
                 ud : out std_logic );
end;

architecture rotary of rotary is
begin
  process (clk) begin
    if (clk'event and clk = '1') then
      if ((a = '0' and b = '1' and y = '0' and z = '0') or 
          (a = '1' and b = '1' and y = '0' and z = '1') or 
          (a = '1' and b = '0' and y = '1' and z = '1') or 
          (a = '0' and b = '0' and y = '1' and z = '0'))
      then
        ud <= '0';
      elsif ((a = '1' and b = '0' and y = '0' and z = '0') or 
             (a = '1' and b = '1' and y = '1' and z = '0') or
             (a = '0' and b = '1' and y = '1' and z = '1') or
             (a = '0' and b = '0' and y = '0' and z = '1'))
      then
        ud <= '1';
      end if;
    end if;
  end process;
end rotary;
----------------------------------------------------
--  Library Name :  updn4
--  Unit    Name :  mem
--  Unit    Type :  Text Unit
----------------------------------------------------
library ieee; use ieee.std_logic_1164.all;

entity  mem  is
    port (y,z : out std_logic ;
      A,B,clk : in std_logic );
end;

architecture  RTL  of  mem  is
begin
  process (clk) begin
    if(clk'event and clk='1') then
      y<=A; z<=B;
    end if;
  end process;
end RTL;
---------------------------------------------------- 
--  Library Name :  updn4
--  Unit    Name :  rot
--  Unit    Type :  Block Diagram
----------------------------------------------------
library ieee; use ieee.std_logic_1164.all;

entity rot is
  port (a,b,clk :  in std_logic;
             ud : out std_logic );
end rot;
 
architecture rot of rot is
  signal y,z : std_logic;
  component mem
      port (    y,z : out std_logic;
            a,b,clk :  in std_logic );
  end component;
  component rotary
      port (y,z,clk,a,b :  in std_logic;
                     ud : out std_logic );
  end component;
begin
  inst_mem: mem
    port map (y=>y,z=>z,b=>b,a=>a,clk=>clk);
  inst_rotary: rotary
    port map (y=>y,z=>z,clk=>clk,ud=>ud,a=>a,b=>b);
end rot;
----------------------------------------------------
--  Library Name :  updn4
--  Unit    Name :  udcnt4
--  Unit    Type :  Text Unit
----------------------------------------------------
library ieee; use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity  udcnt4  is
  port (rst,ud,enb,clk :  in std_logic ;
                 carry : out std_logic ;
                     q : out std_logic_vector (3 downto 0));
end;

architecture  RTL  of  udcnt4 is
signal cnt : std_logic_vector(3 downto 0);
begin
  q<=cnt;
  carry<=((not ud) and enb and (not cnt(0)) and (not cnt(1)) and (not cnt(2)) and (not cnt(3)))
      or (     ud  and enb and      cnt(0)  and      cnt(1)  and      cnt(2)  and      cnt(3) );
  process (clk) begin
    if(clk'event and clk='1') then
      if(rst='1') then
        cnt<="0000";
      elsif(enb='1') then
        if(ud='1') then
          cnt<=cnt+'1';  
        else
          cnt<=cnt-'1';
        end if;
      end if;
    end if;
  end process;
end RTL;
----------------------------------------------------
--  Library Name :  updn4
--  Unit    Name :  DFFR
--  Unit    Type :  Text Unit
----------------------------------------------------
library ieee; use ieee.std_logic_1164.all;

entity  DFFR  is
  port(CLK,D : in std_logic;
        Q,QN :out std_logic);
end DFFR;

architecture  RTL  of  DFFR  is
signal Q_IN : std_logic;
begin
  Q<=Q_IN; QN<=not Q_IN;
  process(CLK) begin
    if(CLK'event and CLK='1') then
      Q_IN <= D;
    end if;
  end process;
end RTL;
----------------------------------------------------
--  Library Name :  updn4
--  Unit    Name :  syncup
--  Unit    Type :  Text Unit
----------------------------------------------------
library ieee; use ieee.std_logic_1164.all;

entity  syncup  is
  port (A,clk :  in std_logic ;
          enb : out std_logic );
end;

architecture  RTL  of  syncup is
  component DFFR
    port(CLK,D :  in std_logic;
          Q,QN : out std_logic);
  end component;
  signal Q1,Q1N,Q2 :std_logic;
begin
  U0:DFFR port map(clk,A,Q1,Q1N);
  U1:DFFR port map(clk,Q1,Q2);
  enb <= Q1N nor Q2;  
end RTL;
----------------------------------------------------
--  Library Name :  updn4
--  Unit    Name :  recnt
--  Unit    Type :  Block Diagram
----------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
entity recnt is
  port (a,b,clk,rst :  in std_logic;
              carry : out std_logic;
                  q : out std_logic_vector(3 downto 0 ) );
end recnt;

architecture recnt of recnt is
  signal enb,ud : std_logic;
  component syncup
      port (a,clk :  in std_logic;
              enb : out std_logic );
  end component;
  component udcnt4
      port (rst,ud,enb,clk :  in std_logic;
                     carry : out std_logic;
                         q : out std_logic_vector(3 downto 0 ) );
  end component;
  component rot
      port (a,b,clk :  in std_logic;
                 ud : out std_logic );
  end component;
begin
  inst_syncup: syncup
    port map (a=>a,enb=>enb,clk=>clk);
  inst_udcnt4: udcnt4
    port map (rst=>rst,ud=>ud,enb=>enb,clk=>clk,carry=>carry,q=>q(3 downto 0));
  inst_rot: rot
    port map (a=>a,b=>b,clk=>clk,ud=>ud);
end recnt;
