----------------------------------------------------
--  Library Name :  updn4
--  Unit    Name :  DFFR
--  Unit    Type :  Text Unit
----------------------------------------------------
library ieee; use ieee.std_logic_1164.all;

entity  DFFR  is
  port(CLK,D : in std_logic;
        Q,QN :out std_logic);
end DFFR;

architecture  RTL  of  DFFR  is
signal Q_IN : std_logic;
begin
  Q<=Q_IN; QN<=not Q_IN;
  process(CLK) begin
    if(CLK'event and CLK='1') then
      Q_IN <= D;
    end if;
  end process;
end RTL;
----------------------------------------------------
--  Library Name :  updn4
--  Unit    Name :  syncup
--  Unit    Type :  Text Unit
----------------------------------------------------
library ieee; use ieee.std_logic_1164.all;

entity  syncup  is
  port (A,clk :  in std_logic ;
          enb : out std_logic );
end;

architecture  RTL  of  syncup is
  component DFFR
    port(CLK,D :  in std_logic;
          Q,QN : out std_logic);
  end component;
  signal Q1,Q1N,Q2 :std_logic;
begin
  U0:DFFR port map(clk,A,Q1,Q1N);
  U1:DFFR port map(clk,Q1,Q2);
  enb <= Q1N nor Q2;  
end RTL;
