----------------------------------------------------
--  Library Name :  updn4
--  Unit    Name :  udcnt4
--  Unit    Type :  Text Unit
----------------------------------------------------
library ieee; use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity  udcnt4  is
  port (rst,ud,enb,clk :  in std_logic ;
                 carry : out std_logic ;
                     q : out std_logic_vector (3 downto 0));
end;

architecture  RTL  of  udcnt4 is
signal cnt : std_logic_vector(3 downto 0);
begin
  q<=cnt;
  carry<=((not ud) and enb and (not cnt(0)) and (not cnt(1)) and (not cnt(2)) and (not cnt(3)))
      or (     ud  and enb and      cnt(0)  and      cnt(1)  and      cnt(2)  and      cnt(3) );
  process (clk) begin
    if(clk'event and clk='1') then
      if(rst='1') then
        cnt<="0000";
      elsif(enb='1') then
        if(ud='1') then
          cnt<=cnt+'1';  
        else
          cnt<=cnt-'1';
        end if;
      end if;
    end if;
  end process;
end RTL;
